#!/usr/bin/env python3

from decimal import Decimal, getcontext
getcontext().prec = 20

n, k, p = input().split()
n, k = int(n), int(k)
p = Decimal(p)

M = 10000

# Compute probability of dying in turn i:
dk = [0]*M
# Probability of dying the latest in turn i:
cdk = [0] * M
# Probability that 1 dies in turn i and all others are already dead.
ans = Decimal(0)
binom = 1
for i in range(k, M):
    dk[i] = binom * (1-p)**k * p**(i-k)
    cdk[i] = cdk[i-1] + dk[i]
    ans += dk[i] * cdk[i-1]**(n-1)
    binom = binom * i // (i-k+1)

print(1-n*ans - Decimal(9.9e-7))
